<?php

namespace QUI\RabbitMQServer\Interface;

use PCSG\Tasks\TaskDataEncryptionKey;
use QUI\Exception;
use PCSG\Tasks\TaskSerializerInterface;

interface RabbitMQProviderInterface
{
    /**
     * @return TaskSchedulerInterface
     * @throws Exception
     */
    public function getTaskScheduler(): TaskSchedulerInterface;

    /**
     * @return TaskSerializerInterface
     * @throws Exception
     */
    public function getTaskSerializer(): TaskSerializerInterface;

    /**
     * @return TaskDataEncryptionKey|null
     * @throws Exception
     */
    public function getTaskDataEncryptionKey(): ?TaskDataEncryptionKey;
}
