<?php

namespace QUI\RabbitMQServer\REST\Route;

use PCSG\RabbitMQ\ApiClient\Entity\LogEntry;
use Psr\Http\Message\ResponseInterface as ResponseInterface;
use QUI\RabbitMQServer\Logger\Logger;
use QUI\RabbitMQServer\Logger\LogType;

class WriteServerLogEntry extends AbstractRoute
{
    private readonly Logger $logger;

    public function __construct()
    {
        $this->logger = new Logger(LogType::SERVER_LOG);
    }

    protected function handleRequest(): ResponseInterface
    {
        try {
            /** @var LogEntry $logEntry */
            $logEntry = $this->getInstanceFromRequest(LogEntry::class);
            $this->logger->log($logEntry);
        } catch (\Exception $exception) {
            return $this->buildExceptionErrorResponse($exception);
        }

        return $this->buildSuccessResponse('Log entry written.');
    }
}
